/*
                                       SAR Mission
 */

#ifndef MISSION_H
#define MISSION_H

#include "obj.h"



/*
 *      Mission objective arrive structure:
 */
typedef struct {

        int type;       /* Must be MISSION_TYPE_ARRIVE. */

	double time_left;	/* In seconds. */

        /* Name of object to arrive at. */
        char *arrive_at_name;

	/* Messages. */
	char	*message_success,
		*message_fail;

} sar_mobj_arrive_struct;


/*
 *	Mission objective rescue humans structure:
 */
typedef struct {

	int type;	/* Must be MISSION_TYPE_RESCUE. */

        double time_left;	/* In seconds. */

	/* Count of humans that need rescue who have been rescued. */
	int humans_rescued, humans_need_rescue;

	/* Count of humans that needed rescue but have died. */
	int humans_died;

	/* Name of object to rescue objectives to. */
	char *arrive_at_name;

        /* Messages. */
        char    *message_success,
                *message_fail;

} sar_mobj_rescue_struct;


/*
 *	Core mission structure:
 */
typedef struct {

#define MISSION_TYPE_NONE	0
#define MISSION_TYPE_ARRIVE	1
#define MISSION_TYPE_RESCUE	2
	int type;	/* Mission type, one of MISSION_TYPE_*. */

#define MISSION_STATE_IN_PROGRESS	0
#define MISSION_STATE_FAILED		1
#define MISSION_STATE_ACCOMPLISHED	2
	int state;	/* Mission state, one of MISSION_STATE_*. */

        char *title;
	char *description;

        char *scene_file;
        char *player_model_file;
        char *player_stats_file;

	void *objective;

	/* Time spend on mission in seconds. */
	double time_spent;

	/* Timmings in milliseconds. */
	time_t next_check, check_int;

} sar_mission_struct;



#endif	/* MISSION_H */
