/*
                    SAR Simulation Utility Functions
 */

#ifndef SIMUTILS_H
#define SIMUTILS_H

#include <sys/types.h>
#include "sfm.h"
#include "obj.h"
#include "sar.h"

extern double SARSimGetFlatContactRadius(sar_object_struct *obj_ptr);
extern sar_object_struct *SARSimMatchObjectFromFDM(
        sar_object_struct **list, int total,
        SFMModelStruct *fdm, int *index
);

extern void SARSimWarpObject(
        sar_scene_struct *scene, sar_object_struct *obj_ptr,
        sar_position_struct *new_pos,
        sar_direction_struct *new_dir
);
extern int SARSimGetLandingGearState(sar_object_struct *obj_ptr);
extern void SARSimUpdateLandingGear(sar_obj_landing_gear_struct *lgear_ptr);
extern void SARSimOpLandingGear(
	sar_scene_struct *scene,
        sar_object_struct ***ptr,
        int *total,
	sar_object_struct *obj_ptr,
	int gear_state
);
extern void SARSimUpdateDoor(sar_obj_door_struct *door_ptr);
extern void SARSimOpDoor(
        sar_scene_struct *scene,
        sar_object_struct ***ptr,
        int *total,
        sar_object_struct *obj_ptr,
        int state
);

extern int SARSimGetEngineState(sar_object_struct *obj_ptr);
extern void SARSimOpEngine(
	sar_scene_struct *scene,
	sar_object_struct ***ptr, 
        int *total,
	sar_object_struct *obj_ptr,
        int engine_state
);

extern int SARSimGetLightsState(sar_object_struct *obj_ptr);
extern void SARSimOpLights( 
        sar_scene_struct *scene,
        sar_object_struct ***ptr,
        int *total,
        sar_object_struct *obj_ptr,
        int state
);
extern int SARSimGetStrobesState(sar_object_struct *obj_ptr);
extern void SARSimOpStrobes(
        sar_scene_struct *scene,
        sar_object_struct ***ptr,
        int *total,
        sar_object_struct *obj_ptr,
        int state
);
extern int SARSimGetAttenuate(sar_object_struct *obj_ptr);
extern void SFMSimOpAttenuate(
        sar_scene_struct *scene,
        sar_object_struct ***ptr, 
        int *total,
        sar_object_struct *obj_ptr,
        int state
);

extern void SARSimSmokeSpawnCheck(
	sar_core_struct *core_ptr,
        sar_object_struct *obj_ptr,
	time_t life_span
);

extern int SARSimDoTouchDownCheck(
        sar_core_struct *core_ptr,
        sar_object_struct *obj_ptr
);
extern int SARSimDoMidFlightCrash(
	sar_core_struct *core_ptr,
	sar_object_struct *obj_ptr,		/* Object that crashed. */
	sar_object_struct *obstruction_obj_ptr	/* Crashed into. */
);
extern int SARSimDoPickUpHuman(
        sar_object_struct *obj_ptr,
	sar_object_human_struct *obj_human_ptr,
	int human_obj_num
);
extern int SARSimDoHoistIn(
        sar_core_struct *core_ptr,
        sar_object_struct *obj_ptr 
);

extern void SARSimSetFlyByPosition(
        sar_scene_struct *scene,
        sar_object_struct ***ptr,   
        int *total,
        sar_object_struct *obj_ptr,
        sar_position_struct *pos_result
);


#endif	/* SIMUTILS_H */
