/*
                           V3D Format File IO
 */
#ifndef V3DFIO_H
#define V3DFIO_H

#include <stdio.h>
#include <sys/types.h>

#include "v3dmp.h"
#include "v3dmodel.h"
#include "v3dtex.h"


#ifndef V3D_COMMENT_CHAR
# define V3D_COMMENT_CHAR	'#'
#endif


extern int V3DLoadModel(
	const char **buf, FILE *fp,
	void ***mh_item, int *total_mh_items,
	v3d_model_struct ***model, int *total_models,
	void *client_data,
	int (*progress_cb)(void *, int, int)
);
extern int V3DSaveModel(
        char ***buf, FILE *fp,
	void **mh_item, int total_mh_items,
	v3d_model_struct **model, int total_models,
	int optimization_level,		/* 0 to 2. */
        void *client_data,
        int (*progress_cb)(void *, int, int)
);


#endif	/* V3DFIO_H */
